## rust-vsock 0.4.0

=== Makefile ===
# Copyright 2019 fsyncd, Berlin, Germany.
# Additional material, copyright of the containerd authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

TOOLCHAIN := x86_64-unknown-linux-musl
VPATH = target/system target/$(TOOLCHAIN)/debug target/$(TOOLCHAIN)/release

SRCS := $(shell find . -type f -name '*.rs' | grep -v 'tests')
ID := $(shell date +%s)

.PHONY: all check clean vsock kmod vm

all: vsock echo_server

check: vsock echo_server test

test:
	cargo test --all

fmt:
	cargo fmt --all -- --check

clippy:
	cargo clippy --all-targets --all-features -- -D warnings

clean:
	cargo clean

vsock: $(SRCS)
	cargo build --lib

echo_server: vsock echo_server/src/main.rs
	cargo build --manifest-path=echo_server/Cargo.toml

# Set up required host kernel modules
kmod:
	sudo /sbin/modprobe -r vmw_vsock_vmci_transport
	sudo /sbin/modprobe -r vmw_vsock_virtio_transport_common
	sudo /sbin/modprobe -r vsock
	sudo /sbin/modprobe vhost_vsock

# Start a virtio socket enabled vm
vm: initrd.cpio
	sudo qemu-system-x86_64 -kernel test_fixture/bzImage -initrd target/$(TOOLCHAIN)/debug/initrd.cpio \
		-enable-kvm -m 256 -device vhost-vsock-pci,id=vhost-vsock-pci0,guest-cid=3 -nographic -append "console=ttyS0"

# Start a virtio socket enabled vm in background
vm-for-action: initrd.cpio
	sudo qemu-system-x86_64 -kernel test_fixture/bzImage -initrd target/$(TOOLCHAIN)/debug/initrd.cpio \
		-m 256 -device vhost-vsock-pci,id=vhost-vsock-pci0,guest-cid=3 -display none -daemonize -append "console=ttyS0"

# Create a simple operating system image for the vm
initrd.cpio: echo_server
	-rm -f target/$(TOOLCHAIN)/debug/initrd.cpio
	mkdir -p /tmp/$(ID)
	cp test_fixture/busybox.cpio /tmp/$(ID)/initrd.cpio
	cp test_fixture/init /tmp/$(ID)/init
	cp echo_server/target/$(TOOLCHAIN)/debug/echo_server /tmp/$(ID)/
	(cd '/tmp/$(ID)' && find . | grep -v 'initrd.cpio' | cpio -H newc -o --append -F initrd.cpio)
	mv /tmp/$(ID)/initrd.cpio target/$(TOOLCHAIN)/debug/
	rm -Rf /tmp/$(ID)

## rust-vsock 0.2.4

=== debian/changelog ===
rust-vsock (0.2.4-4) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.2.4 from crates.io using debcargo 2.6.1
  * Tighten dependencies, this version of vsock is not compatible with nix
    0.27.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 24 Feb 2024 09:27:49 +0000

rust-vsock (0.2.4-3) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.2.4 from crates.io using debcargo 2.5.0
  * Apply upstream patch to fix build with nix 0.24

 -- Peter Michael Green <plugwash@debian.org>  Thu, 09 Jun 2022 23:10:57 +0000

rust-vsock (0.2.4-2) unstable; urgency=medium

  * Source only upload
  * Package vsock 0.2.4 from crates.io using debcargo 2.4.4

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 29 Nov 2021 01:34:27 +0800

rust-vsock (0.2.4-1) unstable; urgency=medium

  * Package vsock 0.2.4 from crates.io using debcargo 2.4.4

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 20 Nov 2021 21:37:20 +0800

=== debian/control ===
Source: rust-vsock
Section: rust
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 25),
 cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-libc-0.2+default-dev (>= 0.2.79-~~) <!nocheck>,
 librust-nix-0.26+default-dev <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Shengjing Zhu <zhsj@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/vsock]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/vsock
Homepage: https://github.com/rust-vsock/vsock-rs
X-Cargo-Crate: vsock
Rules-Requires-Root: no

Package: librust-vsock-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-libc-0.2+default-dev (>= 0.2.79-~~),
 librust-nix-0.26+default-dev
Provides:
 librust-vsock+default-dev (= ${binary:Version}),
 librust-vsock-0-dev (= ${binary:Version}),
 librust-vsock-0+default-dev (= ${binary:Version}),
 librust-vsock-0.2-dev (= ${binary:Version}),
 librust-vsock-0.2+default-dev (= ${binary:Version}),
 librust-vsock-0.2.4-dev (= ${binary:Version}),
 librust-vsock-0.2.4+default-dev (= ${binary:Version})
Description: Virtio socket support for Rust - Rust source code
 Source code for Debianized Rust crate "vsock"

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.2.4 --all-targets --all-features
Features: test-name=rust-vsock:@
Depends: dh-cargo (>= 18), librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.2.4 --all-targets
Features: test-name=librust-vsock-dev:default
Depends: dh-cargo (>= 18), librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.2.4 --all-targets --no-default-features
Features: test-name=librust-vsock-dev:
Depends: dh-cargo (>= 18), librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

## rust-vsock 0.4.0

=== debian/changelog ===
rust-vsock (0.4.0-5) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.4.0 from crates.io using debcargo 2.7.0
  * Upload to unstable.

 -- Peter Michael Green <plugwash@debian.org>  Sun, 03 Nov 2024 19:58:02 +0000

rust-vsock (0.4.0-4) experimental; urgency=medium

  * Team upload.
  * Package vsock 0.4.0 from crates.io using debcargo 2.7.0
  * Add upstream patch to support nix 0.29.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 19 Oct 2024 13:51:00 +0000

rust-vsock (0.4.0-3) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.4.0 from crates.io using debcargo 2.6.1
  * Add workaround for glibc suseconds_t inconsistency.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 02 May 2024 20:20:55 +0000

rust-vsock (0.4.0-2) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.4.0 from crates.io using debcargo 2.6.1
  * Upload to unstable.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 02 May 2024 13:53:39 +0000

rust-vsock (0.4.0-1) experimental; urgency=medium

  * Team upload.
  * Package vsock 0.4.0 from crates.io using debcargo 2.6.1
  * Drop old nix-0.24.patch, no longer needed.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 24 Feb 2024 09:32:26 +0000

=== debian/control ===
Source: rust-vsock
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-cargo (>= 25),
 cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-libc-0.2+default-dev (>= 0.2.150-~~) <!nocheck>,
 librust-nix-0.29+default-dev <!nocheck>,
 librust-nix-0.29+ioctl-dev <!nocheck>,
 librust-nix-0.29+socket-dev <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Shengjing Zhu <zhsj@debian.org>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/vsock]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/vsock
Homepage: https://github.com/rust-vsock/vsock-rs
X-Cargo-Crate: vsock
Rules-Requires-Root: no

Package: librust-vsock-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-libc-0.2+default-dev (>= 0.2.150-~~),
 librust-nix-0.29+default-dev,
 librust-nix-0.29+ioctl-dev,
 librust-nix-0.29+socket-dev
Provides:
 librust-vsock+default-dev (= ${binary:Version}),
 librust-vsock-0-dev (= ${binary:Version}),
 librust-vsock-0+default-dev (= ${binary:Version}),
 librust-vsock-0.4-dev (= ${binary:Version}),
 librust-vsock-0.4+default-dev (= ${binary:Version}),
 librust-vsock-0.4.0-dev (= ${binary:Version}),
 librust-vsock-0.4.0+default-dev (= ${binary:Version})
Description: Virtio socket support for Rust - Rust source code
 Source code for Debianized Rust crate "vsock"

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.4.0 --all-targets --all-features
Features: test-name=rust-vsock:@
Depends: dh-cargo (>= 31), rustc:native, librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.4.0 --all-targets
Features: test-name=librust-vsock-dev:default
Depends: dh-cargo (>= 31), rustc:native, librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.4.0 --all-targets --no-default-features
Features: test-name=librust-vsock-dev:
Depends: dh-cargo (>= 31), rustc:native, librust-rand-0.8+default-dev (>= 0.8.3-~~), librust-sha2+default-dev (>= 0.8.0-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

## rust-vsock 0.5.1

=== debian/changelog ===
rust-vsock (0.5.1-2) unstable; urgency=medium

  * Team upload.
  * Package vsock 0.5.1 from crates.io using debcargo 2.7.8

 -- Peter Michael Green <plugwash@debian.org>  Thu, 25 Sep 2025 12:58:02 +0000

rust-vsock (0.5.1-1) unstable; urgency=medium

  * Team upload
  * Package vsock 0.5.1 from crates.io using debcargo 2.7.8

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 1 Sep 2025 12:07:55 -0400

=== debian/control ===
Source: rust-vsock
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-libc-0.2+default-dev (>= 0.2.158-~~) <!nocheck>,
 librust-nix+default-dev (<< 0.31-~~) <!nocheck>,
 librust-nix+default-dev (>= 0.29.0-~~) <!nocheck>,
 librust-nix+ioctl-dev (<< 0.31-~~) <!nocheck>,
 librust-nix+ioctl-dev (>= 0.29.0-~~) <!nocheck>,
 librust-nix+socket-dev (<< 0.31-~~) <!nocheck>,
 librust-nix+socket-dev (>= 0.29.0-~~) <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Shengjing Zhu <zhsj@debian.org>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/vsock]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/vsock
Homepage: https://github.com/rust-vsock/vsock-rs
X-Cargo-Crate: vsock
Rules-Requires-Root: no

Package: librust-vsock-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-libc-0.2+default-dev (>= 0.2.158-~~),
 librust-nix+default-dev (<< 0.31-~~),
 librust-nix+default-dev (>= 0.29.0-~~),
 librust-nix+ioctl-dev (<< 0.31-~~),
 librust-nix+ioctl-dev (>= 0.29.0-~~),
 librust-nix+socket-dev (<< 0.31-~~),
 librust-nix+socket-dev (>= 0.29.0-~~)
Provides:
 librust-vsock+default-dev (= ${binary:Version}),
 librust-vsock-0-dev (= ${binary:Version}),
 librust-vsock-0+default-dev (= ${binary:Version}),
 librust-vsock-0.5-dev (= ${binary:Version}),
 librust-vsock-0.5+default-dev (= ${binary:Version}),
 librust-vsock-0.5.1-dev (= ${binary:Version}),
 librust-vsock-0.5.1+default-dev (= ${binary:Version})
Description: Virtio socket support for Rust - Rust source code
 Source code for Debianized Rust crate "vsock"

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.5.1 --all-targets --all-features
Features: test-name=rust-vsock:@
Depends: dh-cargo (>= 31), rustc, librust-rand-0.8+default-dev (>= 0.8.5-~~), librust-sha2-0.10+default-dev (>= 0.10.8-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.5.1 --all-targets
Features: test-name=librust-vsock-dev:default
Depends: dh-cargo (>= 31), rustc, librust-rand-0.8+default-dev (>= 0.8.5-~~), librust-sha2-0.10+default-dev (>= 0.10.8-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test vsock 0.5.1 --all-targets --no-default-features
Features: test-name=librust-vsock-dev:
Depends: dh-cargo (>= 31), rustc, librust-rand-0.8+default-dev (>= 0.8.5-~~), librust-sha2-0.10+default-dev (>= 0.10.8-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(.*)\/download/vsock-$1\.tar\.gz/g,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/ \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/vsock .*/crates/vsock/@ANY_VERSION@/download
